<template>
	<div class="q-pa-md q-gutter-sm">
		<q-dialog v-model="userCreate" class="dialog">
			<q-card style="width: 500px;">
				<div class="row">
					<q-card-section>
						<div class="text-h6">Create user</div>
					</q-card-section>
					<q-space />
					<q-card-section>
						<q-btn round dense icon="close" v-close-popup />
					</q-card-section>
				</div>

				<q-card-section class="q-pt-none">
					<q-input
						outlined
						v-model="email"
						label="Email"
						type="email"
						ref="email"
						dense
						:rules="[
							(val) => !!val || 'Field is required',
							isValidEmail,
						]"
					/>
					<q-input
						outlined
						type="number"
						v-model="age"
						label="Age"
						ref="age"
						dense
						:rules="[
							(val) =>
								(val !== null && val !== '') ||
								'Please type your age',
							(val) =>
								(val > 0 && val < 100) ||
								'Please type a real age',
						]"
					/>
					<q-input
						outlined
						v-model="birthDate"
						mask="date"
						label="Date of birth"
						ref="birthDate"
						dense
						:rules="[
							(val) =>
								(val !== null && val !== '') ||
								'Filled is required',
						]"
					>
						<template v-slot:append>
							<q-icon name="event" class="cursor-pointer">
								<q-popup-proxy
									ref="qDateProxy"
									transition-show="scale"
									transition-hide="scale"
								>
									<q-date v-model="birthDate">
										<div
											class="row items-center justify-end"
										>
											<q-btn
												v-close-popup
												label="Close"
												color="primary"
												flat
											/>
										</div>
									</q-date>
								</q-popup-proxy>
							</q-icon>
						</template>
					</q-input>
					<q-input
						outlined
						v-model="userName"
						label="Username"
						type="text"
						ref="userName"
						dense
						:rules="[(val) => !!val || 'Field is required']"
					/>
					<q-input
						outlined
						v-model="password"
						label="Password"
						type="password"
						ref="password"
						dense
						:rules="[(val) => !!val || 'Field is required']"
					/>
					<q-input
						outlined
						v-model="confirmPassword"
						label="Confirm password"
						type="password"
						ref="confirmPassword"
						dense
						:rules="[(val) => !!val || 'Field is required']"
					/>

					<q-select
						outlined
						v-model="level"
						:options="options"
						label="User level"
						ref="level"
						dense
						:rules="[
							(val) =>
								(val !== null && val !== '') ||
								'Filled is required',
						]"
					/>
					<div class="q-pa-md q-gutter-sm">
						<q-dialog
							v-model="alertSuccess"
							persistent
							transition-show="scale"
							transition-hide="scale"
						>
							<q-card
								class="text-white"
								style="width: 300px;"
								:style="{ background: color }"
							>
								<q-card-section>
									<div class="text-h6">{{ title }}</div>
								</q-card-section>

								<q-card-section class="q-pt-none">
									{{ message }}
								</q-card-section>

								<q-card-actions
									align="right"
									class="bg-white text-teal"
								>
									<q-btn flat label="OK" v-close-popup />
								</q-card-actions>
							</q-card>
						</q-dialog>
					</div>
					<q-btn
						style="width: 100%;"
						label="Create"
						color="primary"
						type="button"
						@click="createUser"
					/>
				</q-card-section>
			</q-card>
		</q-dialog>
	</div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";
export default {
	data() {
		return {
			alertSuccess: false,
			message: null,
			title: null,
			color: null,
			// inputs
			email: null,
			age: null,
			birthDate: null,
			userName: null,
			password: null,
			confirmPassword: null,
			level: null,
			options: ["Admin", "Staff"],
		};
	},
	methods: {
		// isValidString(val) {
		// 	const stringPattern = /^[a-zA-Z]+$/;
		// 	return stringPattern.test(val) || "Invalid String";
		// },
		// validate email
		isValidEmail(val) {
			const emailPattern = /^(?=[a-zA-Z0-9@._%+-]{6,254}$)[a-zA-Z0-9._%+-]{1,64}@(?:[a-zA-Z0-9-]{1,63}\.){1,8}[a-zA-Z]{2,63}$/;
			return emailPattern.test(val) || "Invalid email";
		},

		createUser() {
			this.$refs.email.validate();
			this.$refs.age.validate();
			this.$refs.birthDate.validate();
			this.$refs.userName.validate();
			this.$refs.password.validate();
			this.$refs.confirmPassword.validate();
			this.$refs.level.validate();
			if (
				!this.$refs.email.hasError &&
				!this.$refs.age.hasError &&
				!this.$refs.birthDate.hasError &&
				!this.$refs.userName.hasError &&
				!this.$refs.password.hasError &&
				!this.$refs.confirmPassword.hasError
			) {
				this.$axios
					.post(this.host + "/src/php/actions/user.php", {
						email: this.email,
						age: this.age,
						birthDate: this.birthDate,
						userName: this.userName,
						password: this.password,
						confirmPassword: this.confirmPassword,
						level: this.level,
					})
					.then((response) => {
						if (response.data.error) {
							this.title = response.data.title;
							this.message = response.data.message;
							this.color = "red";
						} else {
							this.title = response.data.title;
							this.message = response.data.message;
							this.color = "green";
						}
					});
				this.alertSuccess = true;
			}
		},
	},
	computed: {
		...mapGetters({
			userCreateForm: "showcase/userCreate",
		}),
		userCreate: {
			get() {
				return this.userCreateForm;
			},
			set(val) {
				this.$store.commit("showcase/hideUserCreateForm", val);
			},
		},
		// userEdit: {
		// 	get() {
		// 		return this.editForm;
		// 	},
		// 	set(val) {
		// 		this.$store.commit("showcase/hideUserEditForm", val);
		// 	},
		// },
		// email: {
		// 	get() {
		// 		return this.userEmail;
		// 	},
		// 	set(val) {
		// 		this.$store.commit("showcase/userEmail", val);
		// 	},
		// },
		// age: {
		// 	get() {
		// 		return this.userAge;
		// 	},
		// 	set(val) {
		// 		this.$store.commit("showcase/userAge", val);
		// 	},
		// },
		// birthDate: {
		// 	get() {
		// 		return this.userBirthDate;
		// 	},
		// 	set(val) {
		// 		this.$store.commit("showcase/userBirthDate", val);
		// 	},
		// },
	},
};
</script>
